"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Button = Button;

var _style = _interopRequireDefault(require("styled-jsx/style"));

var React = _interopRequireWildcard(require("react"));

var _constants = require("./constants");

var _excluded = ["block", "btnSize", "btnStyle", "children", "disabled", "onClick", "className"];

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var SIZES = {
  l: 'l',
  m: 'm',
  s: 's'
};
var STYLES = {
  border: 'border',
  emphasis: 'emphasis',
  link: 'link',
  primary: 'primary'
};
{
  /* language=CSS */
}
var sizeLarge = new String("button.jsx-1373177282{-webkit-font-smoothing:antialiased;font-size:2.2rem;font-weight:400;-webkit-letter-spacing:.05rem;-moz-letter-spacing:.05rem;-ms-letter-spacing:.05rem;letter-spacing:.05rem;padding:12px 24px;}");
sizeLarge.__hash = "1373177282";
{
  /* language=CSS */
}
var sizeMedium = new String("button.jsx-957140268{-webkit-font-smoothing:antialiased;font-size:".concat(_constants.FONT_SIZES.M, ";font-weight:400;-webkit-letter-spacing:.02rem;-moz-letter-spacing:.02rem;-ms-letter-spacing:.02rem;letter-spacing:.02rem;padding:9px 22px;}"));
sizeMedium.__hash = "957140268";
{
  /* language=CSS */
}
var sizeSmall = new String("button.jsx-3887718862{-webkit-font-smoothing:antialiased;font-size:".concat(_constants.FONT_SIZES.S, ";font-weight:400;-webkit-letter-spacing:.02rem;-moz-letter-spacing:.02rem;-ms-letter-spacing:.02rem;letter-spacing:.02rem;padding:9px 22px;}"));
sizeSmall.__hash = "3887718862";

var sizeStyle = function sizeStyle(size) {
  switch (size) {
    case SIZES.l:
      return sizeLarge;

    case SIZES.m:
      return sizeMedium;

    case SIZES.s:
      return sizeSmall;

    default:
      return sizeMedium;
  }
};

{
  /* language=CSS */
}
var styleBorder = new String("button.jsx-2083874473{background-color:transparent;border:1px solid ".concat(_constants.COLORS.LINK, ";color:").concat(_constants.COLORS.LINK, ";}button.disabled.jsx-2083874473{border-color:#c4c0c0;color:").concat(_constants.COLORS.DISABLED, ";}"));
styleBorder.__hash = "2083874473";
{
  /* language=CSS */
}
var styleEmphasis = new String("button.jsx-3885501520{background-color:#d0043c;border:1px solid #d0043c;color:#fff;}button.disabled.jsx-3885501520{background-color:#c4c0c0;border-color:#c4c0c0;color:".concat(_constants.COLORS.DISABLED, ";}"));
styleEmphasis.__hash = "3885501520";
{
  /* language=CSS */
}
var styleLink = new String("button.jsx-1196454281{background-color:transparent;border:0;color:".concat(_constants.COLORS.LINK, ";outline:0;padding:0 !important;-webkit-text-decoration:none;text-decoration:none;}button.jsx-1196454281:hover{-webkit-text-decoration:underline;text-decoration:underline;}button.disabled.jsx-1196454281,button.disabled.jsx-1196454281:hover{color:").concat(_constants.COLORS.DISABLED, " !important;-webkit-text-decoration:none;text-decoration:none;}"));
styleLink.__hash = "1196454281";
{
  /* language=CSS */
}
var stylePrimary = new String("button.jsx-1468731469{background-color:#009f94;border:1px solid #009f94;color:#fff;}button.disabled.jsx-1468731469{background-color:#c4c0c0;border-color:#c4c0c0;color:".concat(_constants.COLORS.DISABLED, ";}"));
stylePrimary.__hash = "1468731469";

var styleStyle = function styleStyle(style) {
  switch (style) {
    case STYLES.border:
      return styleBorder;

    case STYLES.emphasis:
      return styleEmphasis;

    case STYLES.link:
      return styleLink;

    case STYLES.primary:
      return stylePrimary;

    default:
      return stylePrimary;
  }
};

function Button(_ref) {
  var block = _ref.block,
      btnSize = _ref.btnSize,
      btnStyle = _ref.btnStyle,
      children = _ref.children,
      disabled = _ref.disabled,
      _onClick = _ref.onClick,
      className = _ref.className,
      otherProps = _objectWithoutProperties(_ref, _excluded);

  var sizeCss = sizeStyle(btnSize);
  var styleCss = styleStyle(btnStyle);
  return (
    /*#__PURE__*/
    React.createElement("button", _extends({
      disabled: disabled,
      onClick: function onClick(event) {
        return _onClick(event);
      },
      type: "button"
    }, otherProps, {
      className: "jsx-".concat(sizeCss.__hash, " jsx-").concat(styleCss.__hash) + " jsx-819466240 " + _style["default"].dynamic([["336943318", [block ? 'block' : 'inline-block']]]) + " " + (otherProps && otherProps.className != null && otherProps.className || (disabled ? "disabled " : "") + (className || "") || "")
    }), children,
    /*#__PURE__*/
    React.createElement(_style["default"], {
      id: sizeCss.__hash
    }, sizeCss),
    /*#__PURE__*/
    React.createElement(_style["default"], {
      id: styleCss.__hash
    }, styleCss),
    /*#__PURE__*/
    React.createElement(_style["default"], {
      id: "819466240"
    }, "button.jsx-819466240{border-radius:4px;cursor:pointer;position:relative;white-space:nowrap;}"),
    /*#__PURE__*/
    React.createElement(_style["default"], {
      id: "336943318",
      dynamic: [block ? 'block' : 'inline-block']
    }, "button.__jsx-style-dynamic-selector{display:".concat(block ? 'block' : 'inline-block', ";}")))
  );
}

Button.defaultProps = {
  btnSize: 'm'
};