"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DatePickerWithData = void 0;
exports.firstWeekDayDate = firstWeekDayDate;
exports.lastWeekDayDate = lastWeekDayDate;

var React = _interopRequireWildcard(require("react"));

var _map2 = _interopRequireDefault(require("lodash/fp/map"));

var _chunk = _interopRequireDefault(require("lodash/fp/chunk"));

var _dateformat = _interopRequireDefault(require("dateformat"));

var _flow = _interopRequireDefault(require("lodash/fp/flow"));

var _DatePicker = require("./DatePicker");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) {
  function isNativeReflectConstruct() {
    if (typeof Reflect === "undefined" || !Reflect.construct) return false;
    if (Reflect.construct.sham) return false;
    if (typeof Proxy === "function") return true;

    try {
      Date.prototype.toString.call(Reflect.construct(Date, [], function () {}));
      return true;
    } catch (e) {
      return false;
    }
  }

  return function () {
    var Super = _getPrototypeOf(Derived),
        result;

    if (isNativeReflectConstruct()) {
      var NewTarget = _getPrototypeOf(this).constructor;

      result = Reflect.construct(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }

    return _possibleConstructorReturn(this, result);
  };
}

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var map = _map2["default"].convert({
  cap: false
});

function firstWeekDayDate(date, locale) {
  var day = date.getDay();
  var diff = locale === "en" ? date.getDate() - day + (day === 0 ? -7 : 0) : date.getDate() - day + (day === 0 ? -6 : 1);
  return new Date(date.setDate(diff));
}

function lastWeekDayDate(date, locale) {
  var day = date.getDay();
  var diff = locale === "en" ? date.getDate() + (6 - day) : date.getDate() + (7 - day);
  return new Date(date.setDate(diff));
}

var lastDate = function lastDate(year, month) {
  return new Date(year, month + 1, 0);
};

function dateRange(start, end) {
  var arr = [];

  for (var dt = start; dt <= end; dt.setDate(dt.getDate() + 1)) {
    arr.push({
      date: (0, _dateformat["default"])(dt, 'yyyy-mm-dd'),
      status: 'unknown'
    });
  }

  return arr;
}

function toWeeks(availability) {
  return (0, _flow["default"])((0, _chunk["default"])(7), map(function (days) {
    return {
      days: days
    };
  }))(availability);
}

function nextMonth(date) {
  return new Date(date.getFullYear(), date.getMonth() + 1);
}

function prevMonth(date) {
  return new Date(date.getFullYear(), date.getMonth() - 1);
}

function monthLabel(date) {
  return "".concat(_dateformat["default"].i18n.monthNames[date.getMonth() + 12], " ").concat(date.getFullYear());
}

var DatePickerWithData =
/*#__PURE__*/
function (_React$Component) {
  _inherits(DatePickerWithData, _React$Component);

  var _super = _createSuper(DatePickerWithData);

  function DatePickerWithData() {
    var _this;

    _classCallCheck(this, DatePickerWithData);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "state", {
      calendarMonthDate: new Date(_this.props.initialDate || _this.props.selectedDate || new Date())
    });

    _defineProperty(_assertThisInitialized(_this), "onNextMonthClick", function () {
      return _this.setState(function (prevState) {
        return {
          calendarMonthDate: nextMonth(prevState.calendarMonthDate)
        };
      });
    });

    _defineProperty(_assertThisInitialized(_this), "onPrevMonthClick", function () {
      return _this.setState(function (prevState) {
        return {
          calendarMonthDate: prevMonth(prevState.calendarMonthDate)
        };
      });
    });

    return _this;
  }

  _createClass(DatePickerWithData, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          selectedDate = _this$props.selectedDate,
          minDate = _this$props.minDate,
          onClose = _this$props.onClose,
          _onDateClick = _this$props.onDateClick,
          isDateAvailable = _this$props.isDateAvailable,
          envLocale = _this$props.envLocale,
          langLocale = _this$props.langLocale;
      var calendarMonthDate = this.state.calendarMonthDate;
      var year = calendarMonthDate.getFullYear();
      var month = calendarMonthDate.getMonth();
      var weeks = toWeeks(dateRange(firstWeekDayDate(new Date(year, month), envLocale), lastWeekDayDate(lastDate(year, month), envLocale)));
      return (
        /*#__PURE__*/
        React.createElement(_DatePicker.DatePicker, {
          envLocale: envLocale,
          langLocale: langLocale,
          weeks: weeks,
          onNextMonthClick: this.onNextMonthClick,
          onPrevMonthClick: this.onPrevMonthClick,
          isLoading: false,
          label: monthLabel(calendarMonthDate),
          onClose: onClose,
          onDateClick: function onDateClick(date) {
            return _onDateClick(date);
          },
          selectedDate: selectedDate,
          minDate: minDate,
          isDateAvailable: isDateAvailable
        })
      );
    }
  }]);

  return DatePickerWithData;
}(React.Component);

exports.DatePickerWithData = DatePickerWithData;
DatePickerWithData.defaultProps = {
  envLocale: 'nb',
  langLocale: 'en'
};