"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DateSelectButton = DateSelectButton;

var _style = _interopRequireDefault(require("styled-jsx/style"));

var React = _interopRequireWildcard(require("react"));

var _dateformat = _interopRequireDefault(require("dateformat"));

var _constants = require("./constants");

var _Calendar4LineBlack24Custom = _interopRequireDefault(require("../static/images/icons/Calendar-4-Line-Black-24-Custom.svg"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var i18n = {
  nb: {
    chooseDate: 'Velg dato',
    shortDateFormatMask: 'dd.mm.yyyy'
  },
  en: {
    chooseDate: 'Choose date',
    shortDateFormatMask: 'mm/dd/yyyy'
  }
};

function DateSelectButton(_ref) {
  var date = _ref.date,
      label = _ref.label,
      locale = _ref.locale,
      onClick = _ref.onClick,
      wrapperClass = _ref.wrapperClass,
      wrapperStyle = _ref.wrapperStyle,
      placeholder = _ref.placeholder;
  var text = i18n[locale];
  _dateformat["default"].masks.shortDate = text.shortDateFormatMask;
  return (
    /*#__PURE__*/
    React.createElement("div", {
      style: wrapperStyle,
      className: _style["default"].dynamic([["3704141118", [_constants.COLORS.SUBTLE, _constants.SPACING.S, _constants.SPACING.S, _constants.FONT_SIZES.S]]]) + " " + (wrapperClass || "")
    },
    /*#__PURE__*/
    React.createElement("label", {
      className: _style["default"].dynamic([["3704141118", [_constants.COLORS.SUBTLE, _constants.SPACING.S, _constants.SPACING.S, _constants.FONT_SIZES.S]]]) + " " + "strong"
    }, label,
    /*#__PURE__*/
    React.createElement("button", {
      onClick: onClick,
      type: "button",
      className: _style["default"].dynamic([["3704141118", [_constants.COLORS.SUBTLE, _constants.SPACING.S, _constants.SPACING.S, _constants.FONT_SIZES.S]]])
    },
    /*#__PURE__*/
    React.createElement("img", {
      alt: "",
      height: "24",
      src: _Calendar4LineBlack24Custom["default"],
      className: _style["default"].dynamic([["3704141118", [_constants.COLORS.SUBTLE, _constants.SPACING.S, _constants.SPACING.S, _constants.FONT_SIZES.S]]])
    }), date ?
    /*#__PURE__*/
    React.createElement("span", {
      className: _style["default"].dynamic([["3704141118", [_constants.COLORS.SUBTLE, _constants.SPACING.S, _constants.SPACING.S, _constants.FONT_SIZES.S]]])
    }, (0, _dateformat["default"])(new Date(date), 'shortDate')) :
    /*#__PURE__*/
    React.createElement("span", {
      className: _style["default"].dynamic([["3704141118", [_constants.COLORS.SUBTLE, _constants.SPACING.S, _constants.SPACING.S, _constants.FONT_SIZES.S]]]) + " " + "choose-date"
    }, placeholder || text.chooseDate))),
    /*#__PURE__*/
    React.createElement(_style["default"], {
      id: "3704141118",
      dynamic: [_constants.COLORS.SUBTLE, _constants.SPACING.S, _constants.SPACING.S, _constants.FONT_SIZES.S]
    }, ".choose-date.__jsx-style-dynamic-selector{color:".concat(_constants.COLORS.SUBTLE, ";}button.__jsx-style-dynamic-selector{-webkit-align-items:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center;background-color:#fff;border:1px solid #aaa;border-radius:2px;display:-webkit-box;display:-webkit-flex;display:-ms-flexbox;display:flex;height:50px;padding:").concat(_constants.SPACING.S, ";cursor:pointer;width:100%;text-align:left;}img.__jsx-style-dynamic-selector{margin-right:").concat(_constants.SPACING.S, ";}label.__jsx-style-dynamic-selector{font-size:").concat(_constants.FONT_SIZES.S, ";}")))
  );
}