"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.EmailInput = EmailInput;
exports.ErrorMessage = ErrorMessage;
exports.FormInput = FormInput;
exports.Label = Label;
exports.NumberInput = NumberInput;
exports.Select = Select;
exports.TelInput = TelInput;
exports.TextInput = TextInput;
exports.Textarea = Textarea;

var _style = _interopRequireDefault(require("styled-jsx/style"));

var React = _interopRequireWildcard(require("react"));

var _excluded = ["children", "description", "errorMessage", "hasError", "id", "label", "onChange", "value", "wrapperStyle", "wrapperClass"],
    _excluded2 = ["errorMessage", "hasError", "id", "onChange", "type", "value", "inputComponent"],
    _excluded3 = ["description", "id", "label", "wrapperStyle", "wrapperClass"],
    _excluded4 = ["description", "id", "label", "wrapperStyle", "wrapperClass"],
    _excluded5 = ["description", "id", "label", "wrapperStyle", "wrapperClass"],
    _excluded6 = ["description", "id", "label", "max", "min", "wrapperStyle", "wrapperClass"],
    _excluded7 = ["description", "errorMessage", "hasError", "id", "label", "onChange", "rows", "value", "inputComponent", "wrapperStyle", "wrapperClass"];

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function Label(_ref) {
  var description = _ref.description,
      htmlFor = _ref.htmlFor,
      label = _ref.label,
      wrapperClass = _ref.wrapperClass,
      wrapperStyle = _ref.wrapperStyle,
      style = _ref.style,
      className = _ref.className;
  return (
    /*#__PURE__*/
    React.createElement("div", {
      style: wrapperStyle,
      className: "jsx-2907270667" + " " + ('mod ' + (wrapperClass || '') || "")
    }, label ?
    /*#__PURE__*/
    React.createElement("label", {
      htmlFor: htmlFor,
      style: style,
      className: "jsx-2907270667" + " " + (className || "")
    }, label) : null, description ?
    /*#__PURE__*/
    React.createElement("div", {
      className: "jsx-2907270667" + " " + "subtle"
    }, description) : null,
    /*#__PURE__*/
    React.createElement(_style["default"], {
      id: "2907270667"
    }, "label.jsx-2907270667{font-size:2.2rem;font-weight:400;}"))
  );
}

function ErrorMessage(_ref2) {
  var children = _ref2.children,
      style = _ref2.style,
      className = _ref2.className;
  return (
    /*#__PURE__*/
    React.createElement("div", {
      style: style,
      className: "jsx-3466745833" + " " + ("mts " + (className || '') || "")
    }, children,
    /*#__PURE__*/
    React.createElement(_style["default"], {
      id: "3466745833"
    }, "div.jsx-3466745833{color:#d93900;}"))
  );
}

{
  /* language=CSS */
}
var defaultInputStyle = new String("input.jsx-2875206823,select.jsx-2875206823,textarea.jsx-2875206823{background-color:#fff;border-radius:2px;border:1px solid #aaa;font-size:1.9rem;font-weight:300;-webkit-letter-spacing:.02rem;-moz-letter-spacing:.02rem;-ms-letter-spacing:.02rem;letter-spacing:.02rem;padding:10px;width:100%;}input.error.jsx-2875206823,select.error.jsx-2875206823,textarea.error.jsx-2875206823{background-color:rgb(255,246,246);border-color:#e0b4b4;color:#9f3a38;}");
defaultInputStyle.__hash = "2875206823";

function Select(_ref3) {
  var children = _ref3.children,
      description = _ref3.description,
      errorMessage = _ref3.errorMessage,
      hasError = _ref3.hasError,
      id = _ref3.id,
      label = _ref3.label,
      _onChange = _ref3.onChange,
      value = _ref3.value,
      wrapperStyle = _ref3.wrapperStyle,
      wrapperClass = _ref3.wrapperClass,
      otherProps = _objectWithoutProperties(_ref3, _excluded);

  return (
    /*#__PURE__*/
    React.createElement("div", {
      style: wrapperStyle,
      className: "jsx-1383359330 " + "jsx-".concat(defaultInputStyle.__hash) + " " + (wrapperClass || "")
    }, label || description ?
    /*#__PURE__*/
    React.createElement(Label, {
      htmlFor: id,
      description: description,
      label: label
    }) : null,
    /*#__PURE__*/
    React.createElement("div", {
      className: "jsx-1383359330 " + "jsx-".concat(defaultInputStyle.__hash) + " " + "mod"
    },
    /*#__PURE__*/
    React.createElement("div", {
      className: "jsx-1383359330 " + "jsx-".concat(defaultInputStyle.__hash) + " " + "select"
    },
    /*#__PURE__*/
    React.createElement("select", _extends({
      id: id,
      onChange: function onChange(event) {
        return _onChange(event.target.value);
      },
      value: value || 'default'
    }, otherProps, {
      className: "jsx-1383359330 " + "jsx-".concat(defaultInputStyle.__hash) + " " + (otherProps && otherProps.className != null && otherProps.className || (hasError ? 'error' : null) || "")
    }), children)), errorMessage ?
    /*#__PURE__*/
    React.createElement(ErrorMessage, null, errorMessage) : null),
    /*#__PURE__*/
    React.createElement(_style["default"], {
      id: defaultInputStyle.__hash
    }, defaultInputStyle),
    /*#__PURE__*/
    React.createElement(_style["default"], {
      id: "1383359330"
    }, ".select.jsx-1383359330{position:relative;width:100%;}.select.jsx-1383359330:before{-webkit-font-smoothing:none;bottom:1px;color:#767676;content:'\\\\25bc';line-height:1;padding-top:0.7em;pointer-events:none;position:absolute;right:0;text-align:center;top:0;-webkit-transform:scale(0.84,0.42);-ms-transform:scale(0.84,0.42);transform:scale(0.84,0.42);width:2em;}select.jsx-1383359330{-webkit-appearance:none;height:50px;padding:13px 30px 13px 10px;}"))
  );
}

function FormInput(_ref4) {
  var errorMessage = _ref4.errorMessage,
      hasError = _ref4.hasError,
      id = _ref4.id,
      _onChange2 = _ref4.onChange,
      type = _ref4.type,
      value = _ref4.value,
      inputComponent = _ref4.inputComponent,
      otherProps = _objectWithoutProperties(_ref4, _excluded2);

  var InputComponent = inputComponent;
  return (
    /*#__PURE__*/
    React.createElement("div", {
      className: "jsx-328736609 " + "jsx-".concat(defaultInputStyle.__hash) + " " + "mod"
    },
    /*#__PURE__*/
    React.createElement(InputComponent, _extends({
      id: id,
      onChange: function onChange(event) {
        return _onChange2(event.target.value);
      },
      type: type,
      value: value
    }, otherProps, {
      className: "jsx-328736609 " + "jsx-".concat(defaultInputStyle.__hash) + " " + (otherProps && otherProps.className != null && otherProps.className || (hasError ? 'error' : null) || "")
    })), errorMessage ?
    /*#__PURE__*/
    React.createElement(ErrorMessage, null, errorMessage) : null,
    /*#__PURE__*/
    React.createElement(_style["default"], {
      id: defaultInputStyle.__hash
    }, defaultInputStyle),
    /*#__PURE__*/
    React.createElement(_style["default"], {
      id: "328736609"
    }, "input.jsx-328736609{height:50px;}"))
  );
}

FormInput.defaultProps = {
  inputComponent: 'input'
};

function TextInput(_ref5) {
  var description = _ref5.description,
      id = _ref5.id,
      label = _ref5.label,
      wrapperStyle = _ref5.wrapperStyle,
      wrapperClass = _ref5.wrapperClass,
      otherProps = _objectWithoutProperties(_ref5, _excluded3);

  return (
    /*#__PURE__*/
    React.createElement("div", {
      style: wrapperStyle,
      className: wrapperClass
    }, label || description ?
    /*#__PURE__*/
    React.createElement(Label, {
      htmlFor: id,
      description: description,
      label: label
    }) : null,
    /*#__PURE__*/
    React.createElement(FormInput, _extends({
      id: id,
      type: "text"
    }, otherProps)))
  );
}

function EmailInput(_ref6) {
  var description = _ref6.description,
      id = _ref6.id,
      label = _ref6.label,
      wrapperStyle = _ref6.wrapperStyle,
      wrapperClass = _ref6.wrapperClass,
      otherProps = _objectWithoutProperties(_ref6, _excluded4);

  return (
    /*#__PURE__*/
    React.createElement("div", {
      style: wrapperStyle,
      className: wrapperClass
    }, label || description ?
    /*#__PURE__*/
    React.createElement(Label, {
      htmlFor: id,
      description: description,
      label: label
    }) : null,
    /*#__PURE__*/
    React.createElement(FormInput, _extends({
      id: id,
      type: "email"
    }, otherProps)))
  );
}

function TelInput(_ref7) {
  var description = _ref7.description,
      id = _ref7.id,
      label = _ref7.label,
      wrapperStyle = _ref7.wrapperStyle,
      wrapperClass = _ref7.wrapperClass,
      otherProps = _objectWithoutProperties(_ref7, _excluded5);

  return (
    /*#__PURE__*/
    React.createElement("div", {
      style: wrapperStyle,
      className: wrapperClass
    }, label || description ?
    /*#__PURE__*/
    React.createElement(Label, {
      htmlFor: id,
      description: description,
      label: label
    }) : null,
    /*#__PURE__*/
    React.createElement(FormInput, _extends({
      id: id,
      type: "tel"
    }, otherProps)))
  );
}

function NumberInput(_ref8) {
  var description = _ref8.description,
      id = _ref8.id,
      label = _ref8.label,
      max = _ref8.max,
      min = _ref8.min,
      wrapperStyle = _ref8.wrapperStyle,
      wrapperClass = _ref8.wrapperClass,
      otherProps = _objectWithoutProperties(_ref8, _excluded6);

  return (
    /*#__PURE__*/
    React.createElement("div", {
      style: wrapperStyle,
      className: wrapperClass
    }, label || description ?
    /*#__PURE__*/
    React.createElement(Label, {
      htmlFor: id,
      description: description,
      label: label
    }) : null,
    /*#__PURE__*/
    React.createElement(FormInput, _extends({
      id: id,
      max: max,
      min: min,
      type: "number"
    }, otherProps)))
  );
}

function Textarea(_ref9) {
  var description = _ref9.description,
      errorMessage = _ref9.errorMessage,
      hasError = _ref9.hasError,
      id = _ref9.id,
      label = _ref9.label,
      _onChange3 = _ref9.onChange,
      rows = _ref9.rows,
      value = _ref9.value,
      inputComponent = _ref9.inputComponent,
      wrapperStyle = _ref9.wrapperStyle,
      wrapperClass = _ref9.wrapperClass,
      otherProps = _objectWithoutProperties(_ref9, _excluded7);

  var InputComponent = inputComponent;
  return (
    /*#__PURE__*/
    React.createElement("div", {
      style: wrapperStyle,
      className: "jsx-2839940173 " + "jsx-".concat(defaultInputStyle.__hash) + " " + (wrapperClass || "")
    }, label || description ?
    /*#__PURE__*/
    React.createElement(Label, {
      htmlFor: id,
      description: description,
      label: label
    }) : null,
    /*#__PURE__*/
    React.createElement("div", {
      className: "jsx-2839940173 " + "jsx-".concat(defaultInputStyle.__hash) + " " + "mod"
    },
    /*#__PURE__*/
    React.createElement(InputComponent, _extends({
      id: id,
      onChange: function onChange(event) {
        return _onChange3(event.target.value);
      },
      rows: rows || 4,
      value: value
    }, otherProps, {
      className: "jsx-2839940173 " + "jsx-".concat(defaultInputStyle.__hash) + " " + (otherProps && otherProps.className != null && otherProps.className || (hasError ? 'error' : null) || "")
    })), errorMessage ?
    /*#__PURE__*/
    React.createElement(ErrorMessage, null, errorMessage) : null),
    /*#__PURE__*/
    React.createElement(_style["default"], {
      id: defaultInputStyle.__hash
    }, defaultInputStyle),
    /*#__PURE__*/
    React.createElement(_style["default"], {
      id: "2839940173"
    }, "textarea.jsx-2839940173{line-height:inherit;resize:vertical;}"))
  );
}

Textarea.defaultProps = {
  inputComponent: 'textarea'
};