"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Col = Col;
exports.ColRight = ColRight;
exports.ColWidths = ColWidths;
exports.Grid = Grid;

var _style = _interopRequireDefault(require("styled-jsx/style"));

var React = _interopRequireWildcard(require("react"));

var _excluded = ["children", "type", "wrap", "className"];

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function Col(_ref) {
  var children = _ref.children,
      flex = _ref.flex,
      style = _ref.style,
      className = _ref.className;
  return (
    /*#__PURE__*/
    React.createElement("div", {
      style: style,
      className: _style["default"].dynamic([["3054834856", [flex || '']]]) + " " + (className || "")
    }, children,
    /*#__PURE__*/
    React.createElement(_style["default"], {
      id: "3054834856",
      dynamic: [flex || '']
    }, "div.__jsx-style-dynamic-selector{-webkit-flex:".concat(flex || '', ";-ms-flex:").concat(flex || '', ";flex:").concat(flex || '', ";overflow:hidden;}")))
  );
}

Col.defaultProps = {
  children: null,
  flex: 1
};

function ColRight(_ref2) {
  var children = _ref2.children;
  return (
    /*#__PURE__*/
    React.createElement("div", {
      className: "jsx-2155691874"
    }, children,
    /*#__PURE__*/
    React.createElement(_style["default"], {
      id: "2155691874"
    }, "div.jsx-2155691874{margin-left:auto;}"))
  );
}

function ColWidths(_ref3) {
  var children = _ref3.children,
      type = _ref3.type,
      width = _ref3.width;
  return (
    /*#__PURE__*/
    React.createElement("div", {
      className: _style["default"].dynamic([["328792655", [width, width, width, width]]]) + " " + (type || "")
    }, children,
    /*#__PURE__*/
    React.createElement(_style["default"], {
      id: "328792655",
      dynamic: [width, width, width, width]
    }, ".xs.__jsx-style-dynamic-selector{width:".concat(width, "%;}@media only screen and (min-width:480px){.s.__jsx-style-dynamic-selector{width:").concat(width, "%;}}@media only screen and (min-width:768px){.m.__jsx-style-dynamic-selector{width:").concat(width, "%;}}@media only screen and (min-width:992px){.l.__jsx-style-dynamic-selector{width:").concat(width, "%;}}")))
  );
}

ColWidths.defaultProps = {
  type: 'm',
  children: undefined
};

function Grid(_ref4) {
  var children = _ref4.children,
      type = _ref4.type,
      wrap = _ref4.wrap,
      className = _ref4.className,
      otherProps = _objectWithoutProperties(_ref4, _excluded);

  var classes = type + " " + (className || "");
  return (
    /*#__PURE__*/
    React.createElement("div", _extends({}, otherProps, {
      className: "jsx-834337674 " + _style["default"].dynamic([["595806592", [wrap || '']]]) + " " + (otherProps && otherProps.className != null && otherProps.className || classes || "")
    }), children,
    /*#__PURE__*/
    React.createElement(_style["default"], {
      id: "595806592",
      dynamic: [wrap || '']
    }, "div.__jsx-style-dynamic-selector{-webkit-flex-wrap:".concat(wrap || '', ";-ms-flex-wrap:").concat(wrap || '', ";flex-wrap:").concat(wrap || '', ";}")),
    /*#__PURE__*/
    React.createElement(_style["default"], {
      id: "834337674"
    }, ".xs.jsx-834337674{display:-webkit-box;display:-webkit-flex;display:-ms-flexbox;display:flex;}@media only screen and (min-width:480px){.s.jsx-834337674{display:-webkit-box;display:-webkit-flex;display:-ms-flexbox;display:flex;}}@media only screen and (min-width:768px){.m.jsx-834337674{display:-webkit-box;display:-webkit-flex;display:-ms-flexbox;display:flex;}}@media only screen and (min-width:992px){.l.jsx-834337674{display:-webkit-box;display:-webkit-flex;display:-ms-flexbox;display:flex;}}"))
  );
}

Grid.defaultProps = {
  children: null,
  id: undefined,
  type: 'm',
  wrap: 'nowrap',
  style: {}
};