"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Header = Header;
exports.HeaderButton = HeaderButton;
exports.HeaderButtonMenu = void 0;
exports.HeaderLink = HeaderLink;
exports.ModalMenuLink = ModalMenuLink;

var _style = _interopRequireDefault(require("styled-jsx/style"));

var React = _interopRequireWildcard(require("react"));

var _HeaderOptionsEventum = require("./HeaderOptionsEventum");

var _Buttons = require("./Buttons");

var _Modal = require("./Modal");

var _constants = require("./constants");

var _eventumIcon_usy2oo = _interopRequireDefault(require("../static/images/eventum-icon_usy2oo.svg"));

var _eventum_logo_doja3b = _interopRequireDefault(require("../static/images/eventum_logo_doja3b.svg"));

var _ArrowDownLineBlack = _interopRequireDefault(require("../static/images/icons/Arrow-Down-Line-Black-24.svg"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) {
  function isNativeReflectConstruct() {
    if (typeof Reflect === "undefined" || !Reflect.construct) return false;
    if (Reflect.construct.sham) return false;
    if (typeof Proxy === "function") return true;

    try {
      Date.prototype.toString.call(Reflect.construct(Date, [], function () {}));
      return true;
    } catch (e) {
      return false;
    }
  }

  return function () {
    var Super = _getPrototypeOf(Derived),
        result;

    if (isNativeReflectConstruct()) {
      var NewTarget = _getPrototypeOf(this).constructor;

      result = Reflect.construct(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }

    return _possibleConstructorReturn(this, result);
  };
}

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function HeaderButton(_ref) {
  var children = _ref.children,
      onClick = _ref.onClick;
  var buttonStyle = {
    color: _constants.COLORS.DEFAULT,
    WebkitFontSmoothing: "auto",
    whiteSpace: "nowrap",
    display: "flex",
    alignItems: "center"
  };
  return (
    /*#__PURE__*/
    React.createElement("div", {
      className: _style["default"].dynamic([["1504515204", [_constants.SPACING.M]]])
    },
    /*#__PURE__*/
    React.createElement(_Buttons.Button, {
      btnSize: "s",
      btnStyle: "link",
      onClick: onClick,
      style: buttonStyle
    }, children),
    /*#__PURE__*/
    React.createElement(_style["default"], {
      id: "1504515204",
      dynamic: [_constants.SPACING.M]
    }, "div.__jsx-style-dynamic-selector{padding:0 ".concat(_constants.SPACING.M, ";}")))
  );
}

function HeaderLink(_ref2) {
  var children = _ref2.children,
      href = _ref2.href,
      onClick = _ref2.onClick;
  return (
    /*#__PURE__*/
    React.createElement("div", {
      className: _style["default"].dynamic([["3859847081", [_constants.COLORS.DEFAULT, _constants.SPACING.M]]])
    },
    /*#__PURE__*/
    React.createElement("a", {
      href: href,
      onClick: onClick,
      className: _style["default"].dynamic([["3859847081", [_constants.COLORS.DEFAULT, _constants.SPACING.M]]])
    }, children),
    /*#__PURE__*/
    React.createElement(_style["default"], {
      id: "3859847081",
      dynamic: [_constants.COLORS.DEFAULT, _constants.SPACING.M]
    }, "a.__jsx-style-dynamic-selector{color:".concat(_constants.COLORS.DEFAULT, " !important;font-weight:400 !important;-webkit-font-smoothing:auto !important;}div.__jsx-style-dynamic-selector{padding:0 ").concat(_constants.SPACING.M, ";}")))
  );
}

var HeaderButtonMenu =
/*#__PURE__*/
function (_React$Component) {
  _inherits(HeaderButtonMenu, _React$Component);

  var _super = _createSuper(HeaderButtonMenu);

  function HeaderButtonMenu() {
    var _this;

    _classCallCheck(this, HeaderButtonMenu);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "state", {
      showOptions: false
    });

    _defineProperty(_assertThisInitialized(_this), "toggleShowOptions", function () {
      _this.setState(function (prevState) {
        return {
          showOptions: !prevState.showOptions
        };
      });
    });

    return _this;
  }

  _createClass(HeaderButtonMenu, [{
    key: "render",
    value: function render() {
      var props = this.props,
          state = this.state,
          toggleShowOptions = this.toggleShowOptions;
      return (
        /*#__PURE__*/
        React.createElement("div", {
          className: _style["default"].dynamic([["313676087", [_constants.SPACING.M]]])
        },
        /*#__PURE__*/
        React.createElement(HeaderButton, {
          onClick: toggleShowOptions
        }, props.buttonChild, props.hasArrow ?
        /*#__PURE__*/
        React.createElement("img", {
          alt: "",
          src: _ArrowDownLineBlack["default"],
          width: "10",
          style: {
            transform: state.showOptions ? 'rotate(180deg)' : 'rotate(0deg)'
          },
          className: _style["default"].dynamic([["313676087", [_constants.SPACING.M]]])
        }) : null),
        /*#__PURE__*/
        React.createElement("div", {
          className: _style["default"].dynamic([["313676087", [_constants.SPACING.M]]]) + " " + "options"
        }, state.showOptions ?
        /*#__PURE__*/
        React.createElement(_Modal.ModalMenu, {
          onClose: toggleShowOptions,
          topLock: props.topLock || 70,
          overlayPosition: props.overlayPosition
        }, props.children) : null),
        /*#__PURE__*/
        React.createElement(_style["default"], {
          id: "313676087",
          dynamic: [_constants.SPACING.M]
        }, ".options.__jsx-style-dynamic-selector{position:relative;margin:0 ".concat(_constants.SPACING.M, ";}img.__jsx-style-dynamic-selector{margin-left:6px;-webkit-transition-duration:250ms;transition-duration:250ms;-webkit-transition-timing-function:ease-in-out;transition-timing-function:ease-in-out;}")))
      );
    }
  }]);

  return HeaderButtonMenu;
}(React.Component);

exports.HeaderButtonMenu = HeaderButtonMenu;

function ModalMenuLink(_ref3) {
  var children = _ref3.children,
      href = _ref3.href,
      onClick = _ref3.onClick,
      style = _ref3.style;

  if (!href && onClick) {
    return (
      /*#__PURE__*/
      React.createElement("button", {
        onClick: onClick,
        style: style,
        className: _style["default"].dynamic([["1296084745", [_constants.COLORS.DEFAULT, _constants.SPACING.M, _constants.COLORS.BORDER, _constants.SPACING.M, _constants.COLORS.DEFAULT]]])
      },
      /*#__PURE__*/
      React.createElement("div", {
        className: _style["default"].dynamic([["1296084745", [_constants.COLORS.DEFAULT, _constants.SPACING.M, _constants.COLORS.BORDER, _constants.SPACING.M, _constants.COLORS.DEFAULT]]])
      }, children),
      /*#__PURE__*/
      React.createElement(_style["default"], {
        id: "1296084745",
        dynamic: [_constants.COLORS.DEFAULT, _constants.SPACING.M, _constants.COLORS.BORDER, _constants.SPACING.M, _constants.COLORS.DEFAULT]
      }, "button.__jsx-style-dynamic-selector{color:".concat(_constants.COLORS.DEFAULT, ";display:block;padding:0 ").concat(_constants.SPACING.M, ";border:0;background-color:transparent;width:100%;text-align:left;cursor:pointer;font-weight:400;outline:0;}div.__jsx-style-dynamic-selector{border-bottom:1px solid ").concat(_constants.COLORS.BORDER, ";padding:").concat(_constants.SPACING.M, " 0;}button.__jsx-style-dynamic-selector:hover div.__jsx-style-dynamic-selector{border-bottom:1px solid ").concat(_constants.COLORS.DEFAULT, ";}")))
    );
  }

  return (
    /*#__PURE__*/
    React.createElement("a", {
      href: href,
      onClick: onClick,
      style: style,
      className: _style["default"].dynamic([["3374003690", [_constants.COLORS.DEFAULT, _constants.SPACING.M, _constants.COLORS.BORDER, _constants.SPACING.M, _constants.COLORS.DEFAULT]]])
    },
    /*#__PURE__*/
    React.createElement("div", {
      className: _style["default"].dynamic([["3374003690", [_constants.COLORS.DEFAULT, _constants.SPACING.M, _constants.COLORS.BORDER, _constants.SPACING.M, _constants.COLORS.DEFAULT]]])
    }, children),
    /*#__PURE__*/
    React.createElement(_style["default"], {
      id: "3374003690",
      dynamic: [_constants.COLORS.DEFAULT, _constants.SPACING.M, _constants.COLORS.BORDER, _constants.SPACING.M, _constants.COLORS.DEFAULT]
    }, "a.__jsx-style-dynamic-selector{color:".concat(_constants.COLORS.DEFAULT, ";display:block;padding:0 ").concat(_constants.SPACING.M, ";-webkit-text-decoration:none;text-decoration:none;}div.__jsx-style-dynamic-selector{border-bottom:1px solid ").concat(_constants.COLORS.BORDER, ";padding:").concat(_constants.SPACING.M, " 0;}a.__jsx-style-dynamic-selector:hover{-webkit-text-decoration:none;text-decoration:none;}a.__jsx-style-dynamic-selector:hover div.__jsx-style-dynamic-selector{border-bottom:1px solid ").concat(_constants.COLORS.DEFAULT, ";}")))
  );
}

function Header(_ref4) {
  var avatarSrc = _ref4.avatarSrc,
      avatarAlt = _ref4.avatarAlt,
      children = _ref4.children,
      locale = _ref4.locale;
  return (
    /*#__PURE__*/
    React.createElement("div", {
      className: _style["default"].dynamic([["3247042322", [_constants.SPACING.M, _constants.SPACING.M, _constants.SPACING.M]]]) + " " + "main"
    },
    /*#__PURE__*/
    React.createElement("div", {
      className: _style["default"].dynamic([["3247042322", [_constants.SPACING.M, _constants.SPACING.M, _constants.SPACING.M]]])
    },
    /*#__PURE__*/
    React.createElement("a", {
      href: "/",
      className: _style["default"].dynamic([["3247042322", [_constants.SPACING.M, _constants.SPACING.M, _constants.SPACING.M]]])
    },
    /*#__PURE__*/
    React.createElement("img", {
      alt: "Eventum symbol",
      height: "34",
      src: _eventumIcon_usy2oo["default"],
      className: _style["default"].dynamic([["3247042322", [_constants.SPACING.M, _constants.SPACING.M, _constants.SPACING.M]]]) + " " + "symbol"
    }),
    /*#__PURE__*/
    React.createElement("img", {
      alt: "Eventum logo",
      height: "23",
      src: _eventum_logo_doja3b["default"],
      className: _style["default"].dynamic([["3247042322", [_constants.SPACING.M, _constants.SPACING.M, _constants.SPACING.M]]]) + " " + "logo"
    }))),
    /*#__PURE__*/
    React.createElement("div", {
      className: _style["default"].dynamic([["3247042322", [_constants.SPACING.M, _constants.SPACING.M, _constants.SPACING.M]]]) + " " + "children"
    }, children), avatarSrc ?
    /*#__PURE__*/
    React.createElement(_HeaderOptionsEventum.AvatarMenu, {
      avatarAlt: avatarAlt,
      avatarSrc: avatarSrc,
      locale: locale
    }) : null,
    /*#__PURE__*/
    React.createElement(_style["default"], {
      id: "3247042322",
      dynamic: [_constants.SPACING.M, _constants.SPACING.M, _constants.SPACING.M]
    }, ".children.__jsx-style-dynamic-selector{-webkit-align-items:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center;display:-webkit-box;display:-webkit-flex;display:-ms-flexbox;display:flex;-webkit-flex:1 auto;-ms-flex:1 auto;flex:1 auto;-webkit-box-pack:end;-webkit-justify-content:flex-end;-ms-flex-pack:end;justify-content:flex-end;}.main.__jsx-style-dynamic-selector{-webkit-align-items:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center;display:-webkit-box;display:-webkit-flex;display:-ms-flexbox;display:flex;font-size:1.7rem;height:70px;}.symbol.__jsx-style-dynamic-selector{margin:8px ".concat(_constants.SPACING.M, " 0;}.logo.__jsx-style-dynamic-selector{display:none;margin:0 ").concat(_constants.SPACING.M, ";}@media only screen and (min-width:768px){.symbol.__jsx-style-dynamic-selector{display:none;}.logo.__jsx-style-dynamic-selector{display:block;}}@media only screen and (min-width:1200px){.main.__jsx-style-dynamic-selector{padding:0 ").concat(_constants.SPACING.M, ";}}")))
  );
}