"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.LocaleSelector = LocaleSelector;
exports.LocaleSelectorWithState = void 0;

var _style = _interopRequireDefault(require("styled-jsx/style"));

var React = _interopRequireWildcard(require("react"));

var _Backdrop = require("./Backdrop");

var _constants = require("./constants");

var _ArrowDownLineBlack = _interopRequireDefault(require("../static/images/icons/Arrow-Down-Line-Black-24.svg"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) {
  function isNativeReflectConstruct() {
    if (typeof Reflect === "undefined" || !Reflect.construct) return false;
    if (Reflect.construct.sham) return false;
    if (typeof Proxy === "function") return true;

    try {
      Date.prototype.toString.call(Reflect.construct(Date, [], function () {}));
      return true;
    } catch (e) {
      return false;
    }
  }

  return function () {
    var Super = _getPrototypeOf(Derived),
        result;

    if (isNativeReflectConstruct()) {
      var NewTarget = _getPrototypeOf(this).constructor;

      result = Reflect.construct(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }

    return _possibleConstructorReturn(this, result);
  };
}

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var i18n = {
  nb: {
    chooseLang: 'Velg språk',
    en: 'Engelsk',
    nb: 'Norsk'
  },
  en: {
    chooseLang: 'Choose language',
    en: 'English',
    nb: 'Norwegian'
  }
};

function Button(_ref) {
  var children = _ref.children,
      className = _ref.className,
      onClick = _ref.onClick;
  return (
    /*#__PURE__*/
    React.createElement("button", {
      onClick: onClick,
      type: "button",
      className: "jsx-3892889344" + " " + "text-s ".concat(className)
    }, children,
    /*#__PURE__*/
    React.createElement(_style["default"], {
      id: "3892889344"
    }, "button.jsx-3892889344{border:0;background-color:transparent;cursor:pointer;outline:0;}"))
  );
}

function CurrentLocale(_ref2) {
  var locale = _ref2.locale,
      isArrowUp = _ref2.isArrowUp,
      onClick = _ref2.onClick;
  var text = i18n[locale];
  return (
    /*#__PURE__*/
    React.createElement("div", {
      className: "jsx-4109443937" + " " + "mam"
    },
    /*#__PURE__*/
    React.createElement(Button, {
      className: "strong",
      onClick: onClick
    }, text[locale],
    /*#__PURE__*/
    React.createElement("img", {
      alt: "",
      src: _ArrowDownLineBlack["default"],
      width: "10",
      style: {
        transform: isArrowUp ? 'rotate(180deg)' : 'rotate(0deg)'
      },
      className: "jsx-4109443937"
    })),
    /*#__PURE__*/
    React.createElement(_style["default"], {
      id: "4109443937"
    }, "img.jsx-4109443937{margin-left:6px;-webkit-transition-duration:250ms;transition-duration:250ms;-webkit-transition-timing-function:ease-in-out;transition-timing-function:ease-in-out;}"))
  );
}

function Option(_ref3) {
  var locale = _ref3.locale,
      _onClick = _ref3.onClick,
      isSelected = _ref3.isSelected,
      children = _ref3.children;
  return (
    /*#__PURE__*/
    React.createElement("li", {
      onClick: function onClick() {
        return _onClick(locale);
      },
      className: "jsx-4074858494" + " " + ((isSelected ? 'strong' : '') || "")
    }, children,
    /*#__PURE__*/
    React.createElement(_style["default"], {
      id: "4074858494"
    }, "li.jsx-4074858494{cursor:pointer;padding:8px 20px;}li.jsx-4074858494:hover{background-color:#ccc;}"))
  );
}

function Options(_ref4) {
  var locale = _ref4.locale,
      onClick = _ref4.onClick;
  var text = i18n[locale];
  return (
    /*#__PURE__*/
    React.createElement("div", {
      className: "jsx-1160068198" + " " + "text-m"
    },
    /*#__PURE__*/
    React.createElement("h4", {
      className: "jsx-1160068198" + " " + "strong"
    }, text.chooseLang),
    /*#__PURE__*/
    React.createElement("hr", {
      className: "jsx-1160068198" + " " + "man"
    }),
    /*#__PURE__*/
    React.createElement("ul", {
      className: "jsx-1160068198"
    },
    /*#__PURE__*/
    React.createElement(Option, {
      locale: _constants.LOCALES.en,
      isSelected: locale === _constants.LOCALES.en,
      onClick: onClick
    }, text[_constants.LOCALES.en]),
    /*#__PURE__*/
    React.createElement(Option, {
      locale: _constants.LOCALES.nb,
      isSelected: locale === _constants.LOCALES.nb,
      onClick: onClick
    }, text[_constants.LOCALES.nb])),
    /*#__PURE__*/
    React.createElement(_style["default"], {
      id: "1160068198"
    }, "div.jsx-1160068198{bottom:23px;position:absolute;right:20px;z-index:1010;background-color:#fff;border:1px solid #ebe8e3;border-radius:3px;box-shadow:0 2px 6px rgba(0,0,0,0.05);text-align:left;min-width:150px;}ul.jsx-1160068198{margin:0;padding:10px 0;}"))
  );
}

function LocaleSelector(_ref5) {
  var locale = _ref5.locale,
      onLocaleSelect = _ref5.onLocaleSelect,
      onShowLocales = _ref5.onShowLocales,
      onHideLocales = _ref5.onHideLocales,
      showLocaleOptions = _ref5.showLocaleOptions;
  return (
    /*#__PURE__*/
    React.createElement("div", {
      style: {
        position: 'relative'
      }
    },
    /*#__PURE__*/
    React.createElement(CurrentLocale, {
      locale: locale,
      isArrowUp: showLocaleOptions,
      onClick: onShowLocales
    }), showLocaleOptions ?
    /*#__PURE__*/
    React.createElement("div", null,
    /*#__PURE__*/
    React.createElement(_Backdrop.Backdrop, {
      onClick: onHideLocales
    }),
    /*#__PURE__*/
    React.createElement(Options, {
      locale: locale,
      onClick: function onClick(selectedLocale) {
        onLocaleSelect(selectedLocale);
      }
    })) : null)
  );
}

var LocaleSelectorWithState =
/*#__PURE__*/
function (_React$Component) {
  _inherits(LocaleSelectorWithState, _React$Component);

  var _super = _createSuper(LocaleSelectorWithState);

  function LocaleSelectorWithState() {
    var _this;

    _classCallCheck(this, LocaleSelectorWithState);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "state", {
      showOptions: false
    });

    _defineProperty(_assertThisInitialized(_this), "toggleShowOptions", function () {
      _this.setState(function (prevState) {
        return {
          showOptions: !prevState.showOptions
        };
      });
    });

    return _this;
  }

  _createClass(LocaleSelectorWithState, [{
    key: "render",
    value: function render() {
      var props = this.props,
          state = this.state,
          toggleShowOptions = this.toggleShowOptions;
      return (
        /*#__PURE__*/
        React.createElement(LocaleSelector, {
          locale: props.locale,
          onHideLocales: toggleShowOptions,
          onLocaleSelect: function onLocaleSelect(selectedLocale) {
            toggleShowOptions();
            props.onSelect(selectedLocale);
          },
          onShowLocales: toggleShowOptions,
          showLocaleOptions: state.showOptions
        })
      );
    }
  }]);

  return LocaleSelectorWithState;
}(React.Component);

exports.LocaleSelectorWithState = LocaleSelectorWithState;