"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Modal = Modal;
exports.ModalMenu = ModalMenu;

var _style = _interopRequireDefault(require("styled-jsx/style"));

var React = _interopRequireWildcard(require("react"));

var _reactResponsive = _interopRequireDefault(require("react-responsive"));

var _Backdrop = require("./Backdrop");

var _ModalCloseButton = require("./ModalCloseButton");

var _constants = require("./constants");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function Modal(_ref) {
  var children = _ref.children,
      onCloseClick = _ref.onCloseClick,
      zIndex = _ref.zIndex,
      enableBodyScroll = _ref.enableBodyScroll;
  return (
    /*#__PURE__*/
    React.createElement(_Backdrop.Backdrop, {
      onClick: onCloseClick,
      bgColor: "rgba(255, 255, 255, 0.8)",
      zIndex: zIndex
    }, !enableBodyScroll &&
    /*#__PURE__*/
    React.createElement(_ModalCloseButton.BodyScrollDisabled, null),
    /*#__PURE__*/
    React.createElement("div", {
      onClick: function onClick(event) {
        return event.stopPropagation();
      },
      role: "presentation",
      className: "jsx-1706657167" + " " + "modal"
    },
    /*#__PURE__*/
    React.createElement(_ModalCloseButton.ModalCloseButton, {
      color: "black",
      onClick: onCloseClick,
      height: 40
    }), children),
    /*#__PURE__*/
    React.createElement(_style["default"], {
      id: "1706657167"
    }, ".modal.jsx-1706657167{background-color:#fff;max-width:100%;min-height:100%;position:absolute;width:850px;}@media only screen and (min-width:768px){.modal.jsx-1706657167{box-shadow:rgba(0,0,0,0.2) 0 1px 10px 0;margin-bottom:60px;margin-top:60px;min-height:auto;padding:15px;}}"))
  );
}

Modal.defaultProps = {
  zIndex: 1001,
  enableBodyScroll: false
};

function ModalMenu(_ref2) {
  var children = _ref2.children,
      onClose = _ref2.onClose,
      topLock = _ref2.topLock,
      bottomLock = _ref2.bottomLock,
      overlayPosition = _ref2.overlayPosition;
  return (
    /*#__PURE__*/
    React.createElement("div", {
      className: _style["default"].dynamic([["2273122308", [bottomLock ? "".concat(bottomLock, "px") : 0, topLock ? "".concat(topLock, "px") : 0, _constants.COLORS.BORDER, bottomLock ? _constants.SPACING.M : 'auto', overlayPosition === 'left' ? 'auto' : 0, overlayPosition === 'left' ? 0 : 'auto', topLock ? _constants.SPACING.S : 'auto']]])
    },
    /*#__PURE__*/
    React.createElement(_reactResponsive["default"], {
      maxWidth: 767
    },
    /*#__PURE__*/
    React.createElement(_ModalCloseButton.BodyScrollDisabled, null)),
    /*#__PURE__*/
    React.createElement(_Backdrop.Backdrop, {
      onClick: onClose
    }),
    /*#__PURE__*/
    React.createElement("div", {
      onClick: function onClick(event) {
        event.stopPropagation();
        onClose();
      },
      role: "presentation",
      className: _style["default"].dynamic([["2273122308", [bottomLock ? "".concat(bottomLock, "px") : 0, topLock ? "".concat(topLock, "px") : 0, _constants.COLORS.BORDER, bottomLock ? _constants.SPACING.M : 'auto', overlayPosition === 'left' ? 'auto' : 0, overlayPosition === 'left' ? 0 : 'auto', topLock ? _constants.SPACING.S : 'auto']]]) + " " + "modal"
    },
    /*#__PURE__*/
    React.createElement("div", {
      className: _style["default"].dynamic([["2273122308", [bottomLock ? "".concat(bottomLock, "px") : 0, topLock ? "".concat(topLock, "px") : 0, _constants.COLORS.BORDER, bottomLock ? _constants.SPACING.M : 'auto', overlayPosition === 'left' ? 'auto' : 0, overlayPosition === 'left' ? 0 : 'auto', topLock ? _constants.SPACING.S : 'auto']]]) + " " + "children"
    }, children)),
    /*#__PURE__*/
    React.createElement(_style["default"], {
      id: "2273122308",
      dynamic: [bottomLock ? "".concat(bottomLock, "px") : 0, topLock ? "".concat(topLock, "px") : 0, _constants.COLORS.BORDER, bottomLock ? _constants.SPACING.M : 'auto', overlayPosition === 'left' ? 'auto' : 0, overlayPosition === 'left' ? 0 : 'auto', topLock ? _constants.SPACING.S : 'auto']
    }, ".children.__jsx-style-dynamic-selector{height:100%;overflow-x:hidden;overflow-y:auto;}.modal.__jsx-style-dynamic-selector{background-color:#fff;bottom:".concat(bottomLock ? "".concat(bottomLock, "px") : 0, ";left:0;position:fixed;right:0;top:").concat(topLock ? "".concat(topLock, "px") : 0, ";z-index:1010;}@media only screen and (min-width:768px){.modal.__jsx-style-dynamic-selector{border-radius:3px;border:1px solid ").concat(_constants.COLORS.BORDER, ";bottom:").concat(bottomLock ? _constants.SPACING.M : 'auto', ";box-shadow:0 2px 6px rgba(0,0,0,0.05);left:").concat(overlayPosition === 'left' ? 'auto' : 0, ";right:").concat(overlayPosition === 'left' ? 0 : 'auto', ";min-width:280px;position:absolute;top:").concat(topLock ? _constants.SPACING.S : 'auto', ";}}")))
  );
}

ModalMenu.defaultProps = {
  overlayPosition: 'left'
};