"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ModalCloseButton = exports.BodyScrollDisabled = void 0;

var _style = _interopRequireDefault(require("styled-jsx/style"));

var React = _interopRequireWildcard(require("react"));

var _CloseLineBlack120Custom = _interopRequireDefault(require("../static/images/icons/Close-Line-Black-120-Custom.svg"));

var _CloseLineWhite = _interopRequireDefault(require("../static/images/icons/Close-Line-White-120.svg"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) {
  function isNativeReflectConstruct() {
    if (typeof Reflect === "undefined" || !Reflect.construct) return false;
    if (Reflect.construct.sham) return false;
    if (typeof Proxy === "function") return true;

    try {
      Date.prototype.toString.call(Reflect.construct(Date, [], function () {}));
      return true;
    } catch (e) {
      return false;
    }
  }

  return function () {
    var Super = _getPrototypeOf(Derived),
        result;

    if (isNativeReflectConstruct()) {
      var NewTarget = _getPrototypeOf(this).constructor;

      result = Reflect.construct(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }

    return _possibleConstructorReturn(this, result);
  };
}

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function disableBodyScroll() {
  var _document = document,
      body = _document.body,
      documentElement = _document.documentElement;
  var scrollTop = Math.max(window.pageYOffset, documentElement ? documentElement.scrollTop : 0, body ? body.scrollTop : 0);

  if (body) {
    body.style.overflow = 'hidden';
    body.style.position = 'fixed';
    body.style.left = '0';
    body.style.right = '0';
    body.style.top = "".concat(-scrollTop, "px");
  }

  return scrollTop;
}

function enableBodyScroll(scrollTop) {
  var _document2 = document,
      body = _document2.body,
      documentElement = _document2.documentElement;

  if (body) {
    body.style.overflow = '';
    body.style.position = '';
    body.style.left = '';
    body.style.right = '';
    body.style.top = '';
    body.scrollTop = scrollTop;
  }

  if (documentElement) {
    documentElement.scrollTop = scrollTop;
  }
}

var BodyScrollDisabled =
/*#__PURE__*/
function (_React$Component) {
  _inherits(BodyScrollDisabled, _React$Component);

  var _super = _createSuper(BodyScrollDisabled);

  function BodyScrollDisabled() {
    var _this;

    _classCallCheck(this, BodyScrollDisabled);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "state", {
      bodyScrollTop: 0
    });

    return _this;
  }

  _createClass(BodyScrollDisabled, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var bodyScrollTop = disableBodyScroll();
      this.setState({
        bodyScrollTop: bodyScrollTop
      });
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var bodyScrollTop = this.state.bodyScrollTop;
      enableBodyScroll(bodyScrollTop);
    }
  }, {
    key: "render",
    value: function render() {
      return null;
    }
  }]);

  return BodyScrollDisabled;
}(React.Component);

exports.BodyScrollDisabled = BodyScrollDisabled;

var ModalCloseButton =
/*#__PURE__*/
function (_React$Component2) {
  _inherits(ModalCloseButton, _React$Component2);

  var _super2 = _createSuper(ModalCloseButton);

  function ModalCloseButton() {
    var _this2;

    _classCallCheck(this, ModalCloseButton);

    for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }

    _this2 = _super2.call.apply(_super2, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this2), "handleKeyDown", function (event) {
      var onClick = _this2.props.onClick;

      if (event.key === 'Escape') {
        onClick();
      }
    });

    return _this2;
  }

  _createClass(ModalCloseButton, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      window.addEventListener('keydown', this.handleKeyDown);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      window.removeEventListener('keydown', this.handleKeyDown);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          onClick = _this$props.onClick,
          height = _this$props.height,
          color = _this$props.color;
      return (
        /*#__PURE__*/
        React.createElement("button", {
          onClick: onClick,
          type: "button",
          className: "jsx-1336004298"
        },
        /*#__PURE__*/
        React.createElement("img", {
          alt: "",
          height: height,
          src: color === 'black' ? _CloseLineBlack120Custom["default"] : _CloseLineWhite["default"],
          className: "jsx-1336004298"
        }),
        /*#__PURE__*/
        React.createElement(_style["default"], {
          id: "1336004298"
        }, "button.jsx-1336004298{border:0;background-color:transparent;outline:0;padding:6px 10px 6px 6px;cursor:pointer;}"))
      );
    }
  }]);

  return ModalCloseButton;
}(React.Component);

exports.ModalCloseButton = ModalCloseButton;

_defineProperty(ModalCloseButton, "defaultProps", {
  color: 'white'
});