"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Checkbox = Checkbox;
exports.Radio = Radio;
exports.CheckboxGroup = exports.RadioGroup = RadioGroup;

var _style = _interopRequireDefault(require("styled-jsx/style"));

var React = _interopRequireWildcard(require("react"));

var _constants = require("./constants");

var _excluded = ["checked", "label", "name", "onChange", "type"],
    _excluded2 = ["checked", "label", "name", "onChange"],
    _excluded3 = ["checked", "label", "name", "onChange"];

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function Input(_ref) {
  var checked = _ref.checked,
      label = _ref.label,
      name = _ref.name,
      _onChange = _ref.onChange,
      type = _ref.type,
      otherProps = _objectWithoutProperties(_ref, _excluded);

  return (
    /*#__PURE__*/
    React.createElement("div", {
      className: _style["default"].dynamic([["1111886675", [_constants.COLORS.DISABLED]]]) + " " + "main"
    },
    /*#__PURE__*/
    React.createElement("label", {
      className: _style["default"].dynamic([["1111886675", [_constants.COLORS.DISABLED]]])
    },
    /*#__PURE__*/
    React.createElement("input", _extends({
      checked: checked,
      name: name,
      onChange: function onChange(event) {
        return _onChange(event.target.checked);
      },
      type: type
    }, otherProps, {
      className: _style["default"].dynamic([["1111886675", [_constants.COLORS.DISABLED]]]) + " " + (otherProps && otherProps.className != null && otherProps.className || "")
    })), label),
    /*#__PURE__*/
    React.createElement(_style["default"], {
      id: "1111886675",
      dynamic: [_constants.COLORS.DISABLED]
    }, ".main.__jsx-style-dynamic-selector{-webkit-align-items:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center;display:-webkit-box;display:-webkit-flex;display:-ms-flexbox;display:flex;margin:5px 0;}input.__jsx-style-dynamic-selector{cursor:pointer;margin:0 10px 5px;}label.__jsx-style-dynamic-selector{-webkit-align-items:baseline;-webkit-box-align:baseline;-ms-flex-align:baseline;align-items:baseline;cursor:pointer;display:-webkit-box;display:-webkit-flex;display:-ms-flexbox;display:flex;}input.__jsx-style-dynamic-selector:disabled,label.__jsx-style-dynamic-selector:disabled{color:".concat(_constants.COLORS.DISABLED, ";cursor:default;}")))
  );
}

function Checkbox(_ref2) {
  var checked = _ref2.checked,
      label = _ref2.label,
      name = _ref2.name,
      onChange = _ref2.onChange,
      otherProps = _objectWithoutProperties(_ref2, _excluded2);

  return (
    /*#__PURE__*/
    React.createElement(Input, _extends({
      checked: checked,
      label: label,
      name: name,
      onChange: onChange,
      type: "checkbox"
    }, otherProps))
  );
}

function Radio(_ref3) {
  var checked = _ref3.checked,
      label = _ref3.label,
      name = _ref3.name,
      onChange = _ref3.onChange,
      otherProps = _objectWithoutProperties(_ref3, _excluded3);

  return (
    /*#__PURE__*/
    React.createElement(Input, _extends({
      checked: checked,
      label: label,
      name: name,
      onChange: onChange,
      type: "radio"
    }, otherProps))
  );
}

function RadioGroup(_ref4) {
  var heading = _ref4.heading,
      description = _ref4.description,
      children = _ref4.children;
  return (
    /*#__PURE__*/
    React.createElement("div", {
      className: _style["default"].dynamic([["3888668521", [_constants.FONT_SIZES.L, _constants.SPACING.M, _constants.SPACING.M, _constants.COLORS.SUBTLE, _constants.SPACING.S]]])
    }, heading ?
    /*#__PURE__*/
    React.createElement("h2", {
      className: _style["default"].dynamic([["3888668521", [_constants.FONT_SIZES.L, _constants.SPACING.M, _constants.SPACING.M, _constants.COLORS.SUBTLE, _constants.SPACING.S]]])
    }, heading) : null,
    /*#__PURE__*/
    React.createElement("fieldset", {
      className: _style["default"].dynamic([["3888668521", [_constants.FONT_SIZES.L, _constants.SPACING.M, _constants.SPACING.M, _constants.COLORS.SUBTLE, _constants.SPACING.S]]])
    },
    /*#__PURE__*/
    React.createElement("legend", {
      className: _style["default"].dynamic([["3888668521", [_constants.FONT_SIZES.L, _constants.SPACING.M, _constants.SPACING.M, _constants.COLORS.SUBTLE, _constants.SPACING.S]]])
    }, description),
    /*#__PURE__*/
    React.createElement("div", {
      className: _style["default"].dynamic([["3888668521", [_constants.FONT_SIZES.L, _constants.SPACING.M, _constants.SPACING.M, _constants.COLORS.SUBTLE, _constants.SPACING.S]]]) + " " + "flex-wrapper"
    }, children)),
    /*#__PURE__*/
    React.createElement(_style["default"], {
      id: "3888668521",
      dynamic: [_constants.FONT_SIZES.L, _constants.SPACING.M, _constants.SPACING.M, _constants.COLORS.SUBTLE, _constants.SPACING.S]
    }, "h2.__jsx-style-dynamic-selector{font-size:".concat(_constants.FONT_SIZES.L, ";margin-bottom:0;}fieldset.__jsx-style-dynamic-selector{margin:0 ").concat(_constants.SPACING.M, " ").concat(_constants.SPACING.M, ";border:0;}legend.__jsx-style-dynamic-selector{color:").concat(_constants.COLORS.SUBTLE, ";margin-bottom:").concat(_constants.SPACING.S, ";}.flex-wrapper.__jsx-style-dynamic-selector{display:-webkit-box;display:-webkit-flex;display:-ms-flexbox;display:flex;-webkit-flex-flow:row wrap;-ms-flex-flow:row wrap;flex-flow:row wrap;}")))
  );
}