"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.DatePickerDemo = void 0;

var _react = _interopRequireDefault(require("react"));

var _dateformat = _interopRequireDefault(require("dateformat"));

var _DateSelectButton = require("../DateSelectButton");

var _constants = require("../constants");

var _DatePickerWithData = require("../DatePickerWithData");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var _default = {
  title: 'DatePicker',
  component: _DatePickerWithData.DatePickerWithData
};
exports["default"] = _default;
var selectedDate = '';
var showDatePicker = false;
var XL = 60;

var toggleShowDatePicker = function toggleShowDatePicker() {
  showDatePicker = !showDatePicker;
};

var today = (0, _dateformat["default"])(new Date(), 'yyyy-mm-dd');

var Template = function Template(args) {
  return (
    /*#__PURE__*/
    _react["default"].createElement("div", {
      style: {
        marginTop: XL,
        display: "flex",
        flexWrap: "wrap"
      }
    },
    /*#__PURE__*/
    _react["default"].createElement("div", null,
    /*#__PURE__*/
    _react["default"].createElement("h2", null, "DatePicker"),
    /*#__PURE__*/
    _react["default"].createElement(_DateSelectButton.DateSelectButton, {
      date: selectedDate,
      locale: "en",
      wrapperStyle: {
        width: 200,
        margin: _constants.SPACING.M
      },
      onClick: toggleShowDatePicker
    }), showDatePicker ?
    /*#__PURE__*/
    _react["default"].createElement(_DatePickerWithData.DatePickerWithData, {
      onClose: toggleShowDatePicker,
      onDateClick: function onDateClick(date) {
        selectedDate = date;
        showDatePicker = false;
      }
    }) : null),
    /*#__PURE__*/
    _react["default"].createElement("div", {
      style: {
        flex: 1
      }
    },
    /*#__PURE__*/
    _react["default"].createElement("h2", null, "Limited by min"),
    /*#__PURE__*/
    _react["default"].createElement(_DateSelectButton.DateSelectButton, {
      date: selectedDate,
      locale: "en",
      wrapperStyle: {
        width: 200,
        margin: _constants.SPACING.M
      },
      onClick: toggleShowDatePicker
    }), showDatePicker ?
    /*#__PURE__*/
    _react["default"].createElement(_DatePickerWithData.DatePickerWithData, {
      onClose: toggleShowDatePicker,
      minDate: today,
      onDateClick: function onDateClick(date) {
        selectedDate = date;
        showDatePicker = false;
      }
    }) : null),
    /*#__PURE__*/
    _react["default"].createElement("div", null,
    /*#__PURE__*/
    _react["default"].createElement("h2", null, "Limited by `isDateAvailable`"),
    /*#__PURE__*/
    _react["default"].createElement(_DateSelectButton.DateSelectButton, {
      date: selectedDate,
      locale: "en",
      wrapperStyle: {
        width: 200,
        margin: _constants.SPACING.M
      },
      onClick: toggleShowDatePicker
    }), showDatePicker ?
    /*#__PURE__*/
    _react["default"].createElement(_DatePickerWithData.DatePickerWithData, {
      onClose: toggleShowDatePicker,
      isDateAvailable: function isDateAvailable(date) {
        var day = new Date(date).getDay();
        return day !== 0 && day !== 6;
      },
      onDateClick: function onDateClick(date) {
        selectedDate = date;
        showDatePicker = false;
      }
    }) : null),
    /*#__PURE__*/
    _react["default"].createElement("div", null,
    /*#__PURE__*/
    _react["default"].createElement("h2", null, "Just button"),
    /*#__PURE__*/
    _react["default"].createElement(_DateSelectButton.DateSelectButton, {
      date: selectedDate,
      locale: "en",
      placeholder: "With placeholder",
      wrapperStyle: {
        width: 200,
        margin: _constants.SPACING.M
      },
      onClick: function onClick() {
        console.log("DateSelect button clicked");
      }
    })))
  );
};

var DatePickerDemo = Template.bind({});
exports.DatePickerDemo = DatePickerDemo;
DatePickerDemo.args = {};