"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.FormDemo = void 0;

var _react = _interopRequireDefault(require("react"));

var _FormComponents = require("../FormComponents");

var _Grid = require("../Grid");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var _default = {
  title: 'Form',
  component: _FormComponents.Select
};
exports["default"] = _default;

var Template = function Template(args) {
  return (
    /*#__PURE__*/
    _react["default"].createElement("div", null,
    /*#__PURE__*/
    _react["default"].createElement("h1", null, "Inputs"),
    /*#__PURE__*/
    _react["default"].createElement(_Grid.Grid, null,
    /*#__PURE__*/
    _react["default"].createElement(_Grid.Col, null,
    /*#__PURE__*/
    _react["default"].createElement(_FormComponents.Select, {
      onChange: function onChange(v) {
        console.log("Selected: ", v);
      },
      label: "3/4 width of wrapper element",
      wrapperStyle: {
        width: "75%"
      }
    },
    /*#__PURE__*/
    _react["default"].createElement("option", {
      value: "1"
    }, "One"),
    /*#__PURE__*/
    _react["default"].createElement("option", {
      value: "2"
    }, "Two"))),
    /*#__PURE__*/
    _react["default"].createElement(_Grid.Col, null,
    /*#__PURE__*/
    _react["default"].createElement(_FormComponents.TextInput, {
      onChange: function onChange(v) {
        console.log("Printed: ", v);
      },
      label: "Just input..."
    }))),
    /*#__PURE__*/
    _react["default"].createElement(_FormComponents.Label, {
      label: "Label with custom wrapper props",
      wrapperClass: "mrgl",
      wrapperStyle: {
        width: "20%"
      }
    }),
    /*#__PURE__*/
    _react["default"].createElement(_FormComponents.TextInput, {
      onChange: function onChange(v) {
        console.log("Printed: ", v);
      },
      errorMessage: "Some Error",
      hasError: true
    }),
    /*#__PURE__*/
    _react["default"].createElement(_Grid.Grid, null,
    /*#__PURE__*/
    _react["default"].createElement(_Grid.Col, null,
    /*#__PURE__*/
    _react["default"].createElement(_FormComponents.Label, {
      label: "Simple label",
      description: "With some desc"
    })),
    /*#__PURE__*/
    _react["default"].createElement(_Grid.Col, null,
    /*#__PURE__*/
    _react["default"].createElement(_FormComponents.Label, {
      label: "With otherProps",
      style: {
        color: "green"
      },
      wrapperStyle: {
        color: "blue"
      },
      className: "mrgl",
      description: "And with wrapperStyle"
    }))))
  );
};

var FormDemo = Template.bind({});
exports.FormDemo = FormDemo;
FormDemo.args = {};